Index: squid/src/client_side.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/client_side.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/client_side.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/client_side.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -2611,14 +2761,14 @@
 void
 clientHttpConnectionsOpen(void)
 {
-    ushortlist *u;
+    sockaddr_in_list *s;
     int fd;
-    for (u = Config.Port.http; u; u = u->next) {
+    for (s = Config.Sockaddr.http; s; s = s->next) {
 	enter_suid();
 	fd = comm_open(SOCK_STREAM,
 	    0,
-	    Config.Addrs.tcp_incoming,
-	    u->i,
+	    s->s.sin_addr,
+	    ntohs(s->s.sin_port),
 	    COMM_NONBLOCKING,
 	    "HTTP Socket");
 	leave_suid();
@@ -2627,8 +2777,10 @@
 	comm_listen(fd);
 	commSetSelect(fd, COMM_SELECT_READ, httpAccept, NULL, 0);
 	/*commSetDefer(fd, httpAcceptDefer, NULL); */
-	debug(1, 1) ("Accepting HTTP connections on port %d, FD %d.\n",
-	    (int) u->i, fd);
+	debug(1, 1) ("Accepting HTTP connections at %s, port %d, FD %d.\n",
+	    inet_ntoa(s->s.sin_addr),
+	    (int) ntohs(s->s.sin_port),
+	    fd);
 	HttpSockets[NHttpSockets++] = fd;
     }
     if (NHttpSockets < 1)
Index: squid/src/comm.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/comm.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/comm.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/comm.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: comm.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: comm.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 5     Socket Functions
  * AUTHOR: Harvest Derived
@@ -39,12 +39,6 @@
 #include <netinet/tcp.h>
 #endif
 
-#if USE_ASYNC_IO
-#define MAX_POLL_TIME 10
-#else
-#define MAX_POLL_TIME 1000
-#endif
-
 typedef struct {
     char *host;
     u_short port;
@@ -166,11 +160,11 @@
 	case ENFILE:
 	case EMFILE:
 	    debug(50, 1) ("comm_open: socket failure: %s\n", xstrerror());
+	    fdAdjustReserved();
 	    break;
 	default:
 	    debug(50, 0) ("comm_open: socket failure: %s\n", xstrerror());
 	}
-	fdAdjustReserved();
 	return -1;
     }
     /* update fdstat */
@@ -308,12 +302,14 @@
     Counter.syscalls.sock.sockets++;
     if (fd2 < 0) {
 	debug(5, 0) ("commResetFD: socket: %s\n", xstrerror());
-	fdAdjustReserved();
+	if (ENFILE == errno || EMFILE == errno)
+	    fdAdjustReserved();
 	return 0;
     }
     if (dup2(fd2, cs->fd) < 0) {
 	debug(5, 0) ("commResetFD: dup2: %s\n", xstrerror());
-	fdAdjustReserved();
+	if (ENFILE == errno || EMFILE == errno)
+	    fdAdjustReserved();
 	return 0;
     }
     close(fd2);
@@ -569,9 +565,6 @@
 comm_close(int fd)
 {
     fde *F = NULL;
-#if USE_ASYNC_IO
-    int doaioclose = 1;
-#endif
     debug(5, 5) ("comm_close: FD %d\n", fd);
     assert(fd >= 0);
     assert(fd < Squid_MaxFD);
@@ -582,30 +575,13 @@
 	return;
     assert(F->flags.open);
     assert(F->type != FD_FILE);
-#ifdef USE_ASYNC_IO
-    if (F->flags.nolinger && F->flags.nonblocking)
-	doaioclose = 0;
-#endif
     F->flags.closing = 1;
     CommWriteStateCallbackAndFree(fd, COMM_ERR_CLOSING);
     commCallCloseHandlers(fd);
     if (F->uses)		/* assume persistent connect count */
 	pconnHistCount(1, F->uses);
     fd_close(fd);		/* update fdstat */
-#if defined(_SQUID_LINUX_)
-    /*
-     * michael@metal.iinet.net.au sez close() on
-     * network sockets never blocks.
-     */
     close(fd);
-#elif USE_ASYNC_IO
-    if (doaioclose)
-	aioClose(fd);
-    else
-	close(fd);
-#else
-    close(fd);
-#endif
     Counter.syscalls.sock.closes++;
 }
 
@@ -744,6 +720,23 @@
     return 0;
 }
 
+int
+commUnsetNonBlocking(int fd)
+{
+    int flags;
+    int dummy = 0;
+    if ((flags = fcntl(fd, F_GETFL, dummy)) < 0) {
+	debug(50, 0) ("FD %d: fcntl F_GETFL: %s\n", fd, xstrerror());
+	return COMM_ERROR;
+    }
+    if (fcntl(fd, F_SETFL, flags & (~SQUID_NONBLOCK)) < 0) {
+	debug(50, 0) ("commUnsetNonBlocking: FD %d: %s\n", fd, xstrerror());
+	return COMM_ERROR;
+    }
+    fd_table[fd].flags.nonblocking = 0;
+    return 0;
+}
+
 void
 commSetCloseOnExec(int fd)
 {
@@ -863,11 +856,7 @@
     state->handler_data = handler_data;
     state->free_func = free_func;
     cbdataLock(handler_data);
-#ifdef OPTIMISTIC_IO
-    commHandleWrite(fd, state);
-#else
     commSetSelect(fd, COMM_SELECT_WRITE, commHandleWrite, state, 0);
-#endif
 }
 
 /* a wrapper around comm_write to allow for MemBuf to be comm_written in a snap */
Index: squid/src/comm_select.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/comm_select.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/comm_select.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/comm_select.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: comm_select.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: comm_select.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 5     Socket Functions
  *
@@ -55,13 +55,16 @@
 #endif
 static int fdIsHttp(int fd);
 static int fdIsIcp(int fd);
+static int fdIsDns(int fd);
 static int commDeferRead(int fd);
 static void checkTimeouts(void);
 static OBJH commIncomingStats;
 #if HAVE_POLL
 static int comm_check_incoming_poll_handlers(int nfds, int *fds);
+static void comm_poll_dns_incoming(void);
 #else
 static int comm_check_incoming_select_handlers(int nfds, int *fds);
+static void comm_select_dns_incoming(void);
 #endif
 
 static struct timeval zero_tv;
@@ -122,10 +125,13 @@
 #define INCOMING_FACTOR 5
 #define MAX_INCOMING_INTERVAL (MAX_INCOMING_INTEGER << INCOMING_FACTOR)
 static int icp_io_events = 0;
+static int dns_io_events = 0;
 static int http_io_events = 0;
 static int incoming_icp_interval = 16 << INCOMING_FACTOR;
+static int incoming_dns_interval = 16 << INCOMING_FACTOR;
 static int incoming_http_interval = 16 << INCOMING_FACTOR;
 #define commCheckICPIncoming (++icp_io_events > (incoming_icp_interval>> INCOMING_FACTOR))
+#define commCheckDNSIncoming (++dns_io_events > (incoming_dns_interval>> INCOMING_FACTOR))
 #define commCheckHTTPIncoming (++http_io_events > (incoming_http_interval>> INCOMING_FACTOR))
 
 static int
@@ -148,6 +154,14 @@
 }
 
 static int
+fdIsDns(int fd)
+{
+    if (fd == DnsSocket)
+	return 1;
+    return 0;
+}
+
+static int
 fdIsHttp(int fd)
 {
     int j;
@@ -158,6 +172,31 @@
     return 0;
 }
 
+#if DELAY_POOLS
+static int slowfdcnt = 0;
+static int slowfdarr[SQUID_MAXFD];
+
+static void
+commAddSlowFd(int fd)
+{
+    assert(slowfdcnt < SQUID_MAXFD);
+    slowfdarr[slowfdcnt++] = fd;
+}
+
+static int
+commGetSlowFd(void)
+{
+    int whichfd, retfd;
+
+    if (!slowfdcnt)
+	return -1;
+    whichfd = squid_random() % slowfdcnt;
+    retfd = slowfdarr[whichfd];
+    slowfdarr[whichfd] = slowfdarr[--slowfdcnt];
+    return retfd;
+}
+#endif
+
 #if HAVE_POLL
 static int
 comm_check_incoming_poll_handlers(int nfds, int *fds)
@@ -184,7 +223,7 @@
 	}
     }
     if (!nfds)
-	return incame;
+	return -1;
 #if !ALARM_UPDATES_TIME
     getCurrentTime();
 #endif
@@ -199,15 +238,17 @@
 	    if ((hdl = fd_table[fd].read_handler)) {
 		fd_table[fd].read_handler = NULL;
 		hdl(fd, &incame);
-	    } else
-		debug(5, 1) ("comm_poll_incoming: NULL read handler\n");
+	    } else if (pfds[i].events & POLLRDNORM)
+		debug(5, 1) ("comm_poll_incoming: FD %d NULL read handler\n",
+		    fd);
 	}
 	if (revents & (POLLWRNORM | POLLOUT | POLLHUP | POLLERR)) {
 	    if ((hdl = fd_table[fd].write_handler)) {
 		fd_table[fd].write_handler = NULL;
 		hdl(fd, &incame);
-	    } else
-		debug(5, 1) ("comm_poll_incoming: NULL write handler\n");
+	    } else if (pfds[i].events & POLLWRNORM)
+		debug(5, 1) ("comm_poll_incoming: FD %d NULL write_handler\n",
+		    fd);
 	}
     }
     return incame;
@@ -270,6 +311,9 @@
 comm_poll(int msec)
 {
     struct pollfd pfds[SQUID_MAXFD];
+#if DELAY_POOLS
+    fd_set slowfds;
+#endif
     PF *hdl = NULL;
     int fd;
     int i;
@@ -277,6 +321,7 @@
     unsigned long nfds;
     int num;
     int callicp = 0, callhttp = 0;
+    int calldns = 0;
     static time_t last_timeout = 0;
     double timeout = current_dtime + (msec / 1000.0);
     double start;
@@ -288,19 +333,39 @@
 #if USE_ASYNC_IO
 	aioCheckCallbacks();
 #endif
+#if DELAY_POOLS
+	FD_ZERO(&slowfds);
+#endif
 	if (commCheckICPIncoming)
 	    comm_poll_icp_incoming();
+	if (commCheckDNSIncoming)
+	    comm_poll_dns_incoming();
 	if (commCheckHTTPIncoming)
 	    comm_poll_http_incoming();
-	callicp = callhttp = 0;
+	callicp = calldns = callhttp = 0;
 	nfds = 0;
 	maxfd = Biggest_FD + 1;
 	for (i = 0; i < maxfd; i++) {
 	    int events;
 	    events = 0;
 	    /* Check each open socket for a handler. */
-	    if (fd_table[i].read_handler && !commDeferRead(i))
-		events |= POLLRDNORM;
+	    if (fd_table[i].read_handler) {
+		switch (commDeferRead(i)) {
+		case 0:
+		    events |= POLLRDNORM;
+		    break;
+		case 1:
+		    break;
+#if DELAY_POOLS
+		case -1:
+		    events |= POLLRDNORM;
+		    FD_SET(i, &slowfds);
+		    break;
+#endif
+		default:
+		    fatalf("bad return value from commDeferRead(FD %d)\n", i);
+		}
+	    }
 	    if (fd_table[i].write_handler)
 		events |= POLLWRNORM;
 	    if (events) {
@@ -350,6 +415,10 @@
 		callicp = 1;
 		continue;
 	    }
+	    if (fdIsDns(fd)) {
+		calldns = 1;
+		continue;
+	    }
 	    if (fdIsHttp(fd)) {
 		callhttp = 1;
 		continue;
@@ -357,15 +426,23 @@
 	    F = &fd_table[fd];
 	    if (revents & (POLLRDNORM | POLLIN | POLLHUP | POLLERR)) {
 		debug(5, 6) ("comm_poll: FD %d ready for reading\n", fd);
-		if ((hdl = F->read_handler)) {
+		if (NULL == (hdl = F->read_handler))
+		    (void) 0;
+#if DELAY_POOLS
+		else if (FD_ISSET(fd, &slowfds))
+		    commAddSlowFd(fd);
+#endif
+		else {
 		    F->read_handler = NULL;
 		    hdl(fd, F->read_data);
 		    Counter.select_fds++;
+		    if (commCheckICPIncoming)
+			comm_poll_icp_incoming();
+		    if (commCheckDNSIncoming)
+			comm_poll_dns_incoming();
+		    if (commCheckHTTPIncoming)
+			comm_poll_http_incoming();
 		}
-		if (commCheckICPIncoming)
-		    comm_poll_icp_incoming();
-		if (commCheckHTTPIncoming)
-		    comm_poll_http_incoming();
 	    }
 	    if (revents & (POLLWRNORM | POLLOUT | POLLHUP | POLLERR)) {
 		debug(5, 5) ("comm_poll: FD %d ready for writing\n", fd);
@@ -373,11 +450,13 @@
 		    F->write_handler = NULL;
 		    hdl(fd, F->write_data);
 		    Counter.select_fds++;
+		    if (commCheckICPIncoming)
+			comm_poll_icp_incoming();
+		    if (commCheckDNSIncoming)
+			comm_poll_dns_incoming();
+		    if (commCheckHTTPIncoming)
+			comm_poll_http_incoming();
 		}
-		if (commCheckICPIncoming)
-		    comm_poll_icp_incoming();
-		if (commCheckHTTPIncoming)
-		    comm_poll_http_incoming();
 	    }
 	    if (revents & POLLNVAL) {
 		close_handler *ch;
@@ -406,14 +485,34 @@
 	}
 	if (callicp)
 	    comm_poll_icp_incoming();
+	if (calldns)
+	    comm_poll_dns_incoming();
 	if (callhttp)
 	    comm_poll_http_incoming();
+#if DELAY_POOLS
+	while ((fd = commGetSlowFd()) != -1) {
+	    fde *F = &fd_table[fd];
+	    debug(5, 6) ("comm_select: slow FD %d selected for reading\n", fd);
+	    if ((hdl = F->read_handler)) {
+		F->read_handler = NULL;
+		hdl(fd, F->read_data);
+		Counter.select_fds++;
+		if (commCheckICPIncoming)
+		    comm_poll_icp_incoming();
+		if (commCheckDNSIncoming)
+		    comm_poll_dns_incoming();
+		if (commCheckHTTPIncoming)
+		    comm_poll_http_incoming();
+	    }
+	}
+#endif
 #if !ALARM_UPDATES_TIME
 	getCurrentTime();
 	Counter.select_time += (current_dtime - start);
 #endif
 	return COMM_OK;
-    } while (timeout > current_dtime);
+    }
+    while (timeout > current_dtime);
     debug(5, 8) ("comm_poll: time out: %d.\n", squid_curtime);
     return COMM_TIMEOUT;
 }
@@ -446,7 +545,7 @@
 	}
     }
     if (maxfd++ == 0)
-	return incame;
+	return -1;
 #if !ALARM_UPDATES_TIME
     getCurrentTime();
 #endif
@@ -461,7 +560,8 @@
 		commUpdateReadBits(fd, NULL);
 		hdl(fd, &incame);
 	    } else {
-		debug(5, 1) ("comm_select_incoming: NULL read handler\n");
+		debug(5, 1) ("comm_select_incoming: FD %d NULL read handler\n",
+		    fd);
 	    }
 	}
 	if (FD_ISSET(fd, &write_mask)) {
@@ -470,7 +570,8 @@
 		commUpdateWriteBits(fd, NULL);
 		hdl(fd, &incame);
 	    } else {
-		debug(5, 1) ("comm_select_incoming: NULL write handler\n");
+		debug(5, 1) ("comm_select_incoming: FD %d NULL write handler\n",
+		    fd);
 	    }
 	}
     }
@@ -535,11 +636,15 @@
 {
     fd_set readfds;
     fd_set writefds;
+#if DELAY_POOLS
+    fd_set slowfds;
+#endif
     PF *hdl = NULL;
     int fd;
     int maxfd;
     int num;
     int callicp = 0, callhttp = 0;
+    int calldns = 0;
     int maxindex;
     int k;
     int j;
@@ -559,11 +664,16 @@
 #if USE_ASYNC_IO
 	aioCheckCallbacks();
 #endif
+#if DELAY_POOLS
+	FD_ZERO(&slowfds);
+#endif
 	if (commCheckICPIncoming)
 	    comm_select_icp_incoming();
+	if (commCheckDNSIncoming)
+	    comm_select_dns_incoming();
 	if (commCheckHTTPIncoming)
 	    comm_select_http_incoming();
-	callicp = callhttp = 0;
+	callicp = calldns = callhttp = 0;
 	maxfd = Biggest_FD + 1;
 	xmemcpy(&readfds, &global_readfds,
 	    howmany(maxfd, FD_MASK_BITS) * FD_MASK_BYTES);
@@ -580,14 +690,30 @@
 		    continue;
 		/* Found a set bit */
 		fd = (j * FD_MASK_BITS) + k;
-		if (commDeferRead(fd))
+		switch (commDeferRead(fd)) {
+		case 0:
+		    break;
+		case 1:
 		    FD_CLR(fd, &readfds);
+		    break;
+#if DELAY_POOLS
+		case -1:
+		    FD_SET(fd, &slowfds);
+		    break;
+#endif
+		default:
+		    fatalf("bad return value from commDeferRead(FD %d)\n", fd);
+		}
 	    }
 	}
 #if DEBUG_FDBITS
 	for (i = 0; i < maxfd; i++) {
 	    /* Check each open socket for a handler. */
+#if DELAY_POOLS
+	    if (fd_table[i].read_handler && commDeferRead(i) != 1) {
+#else
 	    if (fd_table[i].read_handler && !commDeferRead(i)) {
+#endif
 		assert(FD_ISSET(i, &readfds));
 	    }
 	    if (fd_table[i].write_handler) {
@@ -641,10 +767,13 @@
 	    if ((tmask = fdsp[j]) == 0)
 		continue;	/* no bits here */
 	    for (k = 0; k < FD_MASK_BITS; k++) {
+		if (tmask == 0)
+		    break;	/* no more bits left */
 		if (!EBIT_TEST(tmask, k))
 		    continue;
 		/* Found a set bit */
 		fd = (j * FD_MASK_BITS) + k;
+		EBIT_CLR(tmask, k);	/* this will be done */
 #if DEBUG_FDBITS
 		debug(5, 9) ("FD %d bit set for reading\n", fd);
 		assert(FD_ISSET(fd, &readfds));
@@ -653,26 +782,34 @@
 		    callicp = 1;
 		    continue;
 		}
+		if (fdIsDns(fd)) {
+		    calldns = 1;
+		    continue;
+		}
 		if (fdIsHttp(fd)) {
 		    callhttp = 1;
 		    continue;
 		}
 		F = &fd_table[fd];
 		debug(5, 6) ("comm_select: FD %d ready for reading\n", fd);
-		if (F->read_handler) {
-		    hdl = F->read_handler;
+		if (NULL == (hdl = F->read_handler))
+		    (void) 0;
+#if DELAY_POOLS
+		else if (FD_ISSET(fd, &slowfds))
+		    commAddSlowFd(fd);
+#endif
+		else {
 		    F->read_handler = NULL;
 		    commUpdateReadBits(fd, NULL);
 		    hdl(fd, F->read_data);
 		    Counter.select_fds++;
+		    if (commCheckICPIncoming)
+			comm_select_icp_incoming();
+		    if (commCheckDNSIncoming)
+			comm_select_dns_incoming();
+		    if (commCheckHTTPIncoming)
+			comm_select_http_incoming();
 		}
-		if (commCheckICPIncoming)
-		    comm_select_icp_incoming();
-		if (commCheckHTTPIncoming)
-		    comm_select_http_incoming();
-		EBIT_CLR(tmask, k);	/* this bit is done */
-		if (tmask == 0)
-		    break;	/* and no more bits left */
 	    }
 	}
 	fdsp = (fd_mask *) & writefds;
@@ -680,10 +817,13 @@
 	    if ((tmask = fdsp[j]) == 0)
 		continue;	/* no bits here */
 	    for (k = 0; k < FD_MASK_BITS; k++) {
+		if (tmask == 0)
+		    break;	/* no more bits left */
 		if (!EBIT_TEST(tmask, k))
 		    continue;
 		/* Found a set bit */
 		fd = (j * FD_MASK_BITS) + k;
+		EBIT_CLR(tmask, k);	/* this will be done */
 #if DEBUG_FDBITS
 		debug(5, 9) ("FD %d bit set for writing\n", fd);
 		assert(FD_ISSET(fd, &writefds));
@@ -692,39 +832,93 @@
 		    callicp = 1;
 		    continue;
 		}
+		if (fdIsDns(fd)) {
+		    calldns = 1;
+		    continue;
+		}
 		if (fdIsHttp(fd)) {
 		    callhttp = 1;
 		    continue;
 		}
 		F = &fd_table[fd];
 		debug(5, 5) ("comm_select: FD %d ready for writing\n", fd);
-		if (F->write_handler) {
-		    hdl = F->write_handler;
+		if ((hdl = F->write_handler)) {
 		    F->write_handler = NULL;
 		    commUpdateWriteBits(fd, NULL);
 		    hdl(fd, F->write_data);
 		    Counter.select_fds++;
+		    if (commCheckICPIncoming)
+			comm_select_icp_incoming();
+		    if (commCheckDNSIncoming)
+			comm_select_dns_incoming();
+		    if (commCheckHTTPIncoming)
+			comm_select_http_incoming();
 		}
-		if (commCheckICPIncoming)
-		    comm_select_icp_incoming();
-		if (commCheckHTTPIncoming)
-		    comm_select_http_incoming();
-		EBIT_CLR(tmask, k);	/* this bit is done */
-		if (tmask == 0)
-		    break;	/* and no more bits left */
 	    }
 	}
 	if (callicp)
 	    comm_select_icp_incoming();
+	if (calldns)
+	    comm_select_dns_incoming();
 	if (callhttp)
 	    comm_select_http_incoming();
+#if DELAY_POOLS
+	while ((fd = commGetSlowFd()) != -1) {
+	    F = &fd_table[fd];
+	    debug(5, 6) ("comm_select: slow FD %d selected for reading\n", fd);
+	    if ((hdl = F->read_handler)) {
+		F->read_handler = NULL;
+		commUpdateReadBits(fd, NULL);
+		hdl(fd, F->read_data);
+		Counter.select_fds++;
+		if (commCheckICPIncoming)
+		    comm_select_icp_incoming();
+		if (commCheckDNSIncoming)
+		    comm_select_dns_incoming();
+		if (commCheckHTTPIncoming)
+		    comm_select_http_incoming();
+	    }
+	}
+#endif
 	return COMM_OK;
-    } while (timeout > current_dtime);
+    }
+    while (timeout > current_dtime);
     debug(5, 8) ("comm_select: time out: %d\n", (int) squid_curtime);
     return COMM_TIMEOUT;
 }
 #endif
 
+static void
+#if HAVE_POLL
+comm_poll_dns_incoming(void)
+#else
+comm_select_dns_incoming(void)
+#endif
+{
+    int nfds = 0;
+    int fds[2];
+    int nevents;
+    dns_io_events = 0;
+    if (DnsSocket < 0)
+	return;
+    fds[nfds++] = DnsSocket;
+#if HAVE_POLL
+    nevents = comm_check_incoming_poll_handlers(nfds, fds);
+#else
+    nevents = comm_check_incoming_select_handlers(nfds, fds);
+#endif
+    if (nevents < 0)
+	return;
+    incoming_dns_interval += Config.comm_incoming.dns_average - nevents;
+    if (incoming_dns_interval < Config.comm_incoming.dns_min_poll)
+	incoming_dns_interval = Config.comm_incoming.dns_min_poll;
+    if (incoming_dns_interval > MAX_INCOMING_INTERVAL)
+	incoming_dns_interval = MAX_INCOMING_INTERVAL;
+    if (nevents > INCOMING_DNS_MAX)
+	nevents = INCOMING_DNS_MAX;
+    statHistCount(&Counter.comm_dns_incoming, nevents);
+}
+
 void
 comm_select_init(void)
 {
@@ -839,6 +1033,8 @@
     StatCounters *f = &Counter;
     storeAppendPrintf(sentry, "Current incoming_icp_interval: %d\n",
 	incoming_icp_interval >> INCOMING_FACTOR);
+    storeAppendPrintf(sentry, "Current incoming_dns_interval: %d\n",
+	incoming_dns_interval >> INCOMING_FACTOR);
     storeAppendPrintf(sentry, "Current incoming_http_interval: %d\n",
 	incoming_http_interval >> INCOMING_FACTOR);
     storeAppendPrintf(sentry, "\n");
@@ -850,6 +1046,12 @@
 #endif
     statHistDump(&f->comm_icp_incoming, sentry, statHistIntDumper);
 #ifdef HAVE_POLL
+    storeAppendPrintf(sentry, "DNS Messages handled per comm_poll_dns_incoming() call:\n");
+#else
+    storeAppendPrintf(sentry, "DNS Messages handled per comm_select_dns_incoming() call:\n");
+#endif
+    statHistDump(&f->comm_dns_incoming, sentry, statHistIntDumper);
+#ifdef HAVE_POLL
     storeAppendPrintf(sentry, "HTTP Messages handled per comm_poll_http_incoming() call:\n");
 #else
     storeAppendPrintf(sentry, "HTTP Messages handled per comm_select_http_incoming() call:\n");
Index: squid/src/debug.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/debug.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/debug.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/debug.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: debug.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: debug.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 0     Debug Routines
  * AUTHOR: Harvest Derived
@@ -202,6 +202,11 @@
 	    return;
 #endif
 
+    /*
+     * NOTE: we cannot use xrename here without having it in a
+     * separate file -- tools.c has too many dependencies to be
+     * used everywhere debug.c is used.
+     */
     /* Rotate numbers 0 through N up one */
     for (i = Config.Log.rotateNumber; i > 1;) {
 	i--;
@@ -365,7 +370,7 @@
  * info for deducing the current execution stack
  */
 static void
-ctx_print()
+ctx_print(void)
 {
     /* lock so _db_print will not call us recursively */
     Ctx_Lock++;
Index: squid/src/defines.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/defines.h,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/defines.h	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/defines.h	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: defines.h,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: defines.h,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -205,10 +205,6 @@
 
 #define STORE_ENTRY_WITH_MEMOBJ		1
 #define STORE_ENTRY_WITHOUT_MEMOBJ	0
-#define STORE_SWAP_BUF		DISK_PAGE_SIZE
-#define VM_WINDOW_SZ		DISK_PAGE_SIZE
-
-#define SKIP_BASIC_SZ ((size_t) 6)
 
 #define PINGER_PAYLOAD_SZ 8192
 
@@ -246,6 +242,10 @@
  */
 #define INCOMING_ICP_MAX 15
 /*
+ * Max number of DNS messages to receive per call to DNS read handler
+ */
+#define INCOMING_DNS_MAX 15
+/*
  * Max number of HTTP connections to accept per call to httpAccept
  * and PER HTTP PORT
  */
@@ -260,13 +260,18 @@
 
 #define CLIENT_SOCK_SZ 4096
 
-#define URI_WHITESPACE_DENY 0
+#define URI_WHITESPACE_STRIP 0
 #define URI_WHITESPACE_ALLOW 1
 #define URI_WHITESPACE_ENCODE 2
 #define URI_WHITESPACE_CHOP 3
+#define URI_WHITESPACE_DENY 4
 
 #ifndef _PATH_DEVNULL
 #define _PATH_DEVNULL "/dev/null"
 #endif
 
-#define USE_TRUNCATE_NOT_UNLINK 1
+#if USE_ASYNC_IO
+#ifndef NUMTHREADS
+#define NUMTHREADS 16
+#endif
+#endif
Index: squid/src/delay_pools.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/delay_pools.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/delay_pools.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/delay_pools.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: delay_pools.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: delay_pools.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 77    Delay Pools
  * AUTHOR: David Luyer <luyer@ucs.uwa.edu.au>
@@ -149,7 +149,7 @@
 }
 
 void
-delayFreeDelayData()
+delayFreeDelayData(void)
 {
     safe_free(delay_data);
     if (!delay_id_ptr_hash)
@@ -283,6 +283,7 @@
     memset(&ch, '\0', sizeof(ch));
     ch.src_addr = r->client_addr;
     ch.my_addr = r->my_addr;
+    ch.my_port = r->my_port;
     ch.request = r;
     for (pool = 0; pool < Config.Delay.pools; pool++) {
 	if (aclCheckFast(Config.Delay.access[pool], &ch))
